/*
 * Copyright 2013, Red Hat, Inc., and individual contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.cdi.tck.interceptors.tests.contract.aroundConstruct.bindings;

import static org.testng.Assert.fail;

import jakarta.annotation.Priority;
import jakarta.interceptor.AroundConstruct;
import jakarta.interceptor.Interceptor;
import jakarta.interceptor.InvocationContext;

@Interceptor
@CharlieBinding
@Priority(1000)
public class CharlieInterceptor1 extends AbstractInterceptor {

    @AroundConstruct
    public void aroundConstruct(InvocationContext ctx) {
        try {
            ctx.proceed();
            fail();
        } catch (CharlieException expected) {
            setInvoked();
            throw expected;
        } catch (Exception e) {
            fail();
        }
    }

}
